# C++20 STL Cookbook

<a href="https://www.packtpub.com/product/c-20-stl-cookbook/9781803248714?utm_source=github&utm_medium=repository&utm_campaign=9781803248714"><img src="https://static.packt-cdn.com/products/9781803248714/cover/smaller" alt="C++20 STL Cookbook" height="256px" align="right"></a>

This is the code repository for [C++20 STL Cookbook](https://www.packtpub.com/product/c-20-stl-cookbook/9781803248714?utm_source=github&utm_medium=repository&utm_campaign=9781803248714), published by Packt.

**Leverage the latest features of the STL to solve real-world problems**

## What is this book about?
Fast, efficient, and flexible, the C++ programming language has come a long way and is used in every area of the industry to solve many problems. The latest version C++20 will see programmers change the way they code as it brings a whole array of features enabling the quick deployment of applications. This book will get you up and running with using the STL in the best way possible. 

This book covers the following exciting features:
* Understand the new language features and the problems they can solve
* Implement generic features of the STL with practical examples
* Understand standard support classes for concurrency and synchronization
* Perform efficient memory management using the STL
* Implement seamless formatting using std::format
* Work with strings the STL way instead of handcrafting C-style code

If you feel this book is for you, get your [copy](https://www.amazon.com/dp/1803248718) today!

<a href="https://www.packtpub.com/?utm_source=github&utm_medium=banner&utm_campaign=GitHubBanner"><img src="https://raw.githubusercontent.com/PacktPublishing/GitHub/master/GitHub.png" 
alt="https://www.packtpub.com/" border="5" /></a>

## Instructions and Navigations
All of the code is organized into folders. For example, Chapter02.

The code will look like the following:
```
int main() {    
    Frac f{ 5, 3 };    
    cout << format("Frac: {}\n", f);
}
```

**Following is what you need for this book:**
This book is for intermediate to advanced C++ programmers who want to get the most out of the Standard Template Library of C++20, the newest version of C++. Basic knowledge of coding and C++ concepts is necessary to get started with this book.

With the following software and hardware list you can run all code files present in the book (Chapter 1-11).
### Software and Hardware List
| Chapter | Software required | OS required |
| -------- | ------------------------------------ | ----------------------------------- |
| 1-11 | GCC 11.2 | Windows, Mac OS X, and Linux (Any) |
| 1-11 | LLVM/Clang 13.16 | Windows, Mac OS X, and Linux (Any) |
| 1-11 | Microsoft C++ 19.32.31302 | Windows, Mac OS X, and Linux (Any) |

### Related products
* The Art of Writing Efficient Programs [[Packt]](https://www.packtpub.com/product/the-art-of-writing-efficient-programs/9781800208117?utm_source=github&utm_medium=repository&utm_campaign=9781800208117) [[Amazon]](https://www.amazon.com/dp/1800208111)

* Software Architecture with C++ [[Packt]](https://www.packtpub.com/product/software-architecture-with-c/9781838554590?utm_source=github&utm_medium=repository&utm_campaign=9781838554590) [[Amazon]](https://www.amazon.com/dp/1838554599)

## Get to Know the Author
**Bill Weinman**
 has been involved in technology since he built his first computer at age 16, in 1971. He's been coding in C and C++ since the early 1970s. He's written systems and applications for major clients, including NASA, Bank of America, Xerox, IBM, and the US Navy. Also an electronics engineer, he previously worked on the Voyager II spacecraft, audio amplifiers for SAE, and sound systems for Altec Lansing.

Since the mid 1990s, Mr. Weinman has focused on writing and teaching. His books and courses cover HTML, SQL, CGI, Python, and, of course, C and C++. An early contributor to online learning, his clear, concise writing has made his courses a popular feature on lynda.com and LinkedIn Learning.

Follow Bill on his website at bw.org.
